	include 'dix_def.inc'
c
c Include file for memtab (memory tables)
c this file is used in the DIX_MEMTAB_LIBRARY
c
	integer*4  magic_length
	parameter (magic_length=4)
	character*(magic_length) memtab_magic
	parameter (memtab_magic = 'MEMT')	!magic word for sanity checking
c
	structure /memtab_label/		!label entry
	  integer*4 p_next                      !pointer  to the next (or 0)
	  integer*4 ptr_line			!pointer to the line in the memtab
	  character*(max_label_length) label	!label name
	end structure
c
	structure /memtab/			!total memtab control structure
	  character*(magic_length) magic	!magic word for sanity checking
	  integer*4 p_first			!pointer to the first line in the list
	  integer*4 p_last			!pointer to the last line in the list
	  integer*4 p_current			!pointer to the current line in the list
	  integer*4 max_width			!maximum width
	  integer*4 n_labels			!count of labels
	  integer*4 p_labels	                !pointer to label list
	  integer*4 n_lines                     !#lines in memory table
	  integer*4 nk_filename                 !length of memory table name
	  character*(max_filename_length) filename  !name of memory table
	  record /vm_zone/ zone_mem		!memory zone info
	end structure
c
	structure /memtab_ovhd/
	  integer*4 p_next
	  integer*4 p_prev
	  character*(magic_length) magic
	  integer*4 line_nr
	  integer*4 p_pointers
	  integer*4 level
	  integer*4 labelptr
	  integer*4 nk
	end structure
	structure /memtab_line/
	  record /memtab_ovhd/ ovhd
	  character*(max_line_length) line
	end structure	  	  
